找回密码
 立即注册

QQ登录

只需一步,快速开始

扫一扫,访问微社区

查看: 1192|回复: 0

[分享] Intersect line with curve

[复制链接]

已领礼包: 859个

财富等级: 财运亨通

发表于 2014-6-7 01:12:08 | 显示全部楼层 |阅读模式

马上注册,结交更多好友,享用更多功能,让你轻松玩转社区。

您需要 登录 才可以下载或查看,没有账号?立即注册

×
        [CommandMethod("IntLineCurve","ilw", CommandFlags.Modal | CommandFlags.UsePickSet | CommandFlags.Redraw )]
        public void IntersectTestIn()
        {
            Database db = HostApplicationServices.WorkingDatabase;
            Document doc = Autodesk.AutoCAD.ApplicationServices.Application.DocumentManager.MdiActiveDocument;
            Editor ed = doc.Editor;
            using (Transaction tr = db.TransactionManager.StartTransaction())
            {

                PromptEntityOptions peo = new PromptEntityOptions("\nSelect a Line >>");
                peo.SetRejectMessage("\nYou have to select the Line only >>");
                peo.AddAllowedClass(typeof(Line), false);
                PromptEntityResult res;
                res = ed.GetEntity(peo);
                if (res.Status != PromptStatus.OK)
                    return;
                Entity ent = (Entity)tr.GetObject(res.ObjectId, OpenMode.ForRead);
                if (ent == null)
                    return;
                Line line = (Line)ent as Line;
                if (line == null) return;

                peo = new PromptEntityOptions("\nSelect a curve: ");
                peo.SetRejectMessage("\nYou have to select the curve only >>");
                peo.AddAllowedClass(typeof(Curve), false);
                res = ed.GetEntity(peo);
                if (res.Status != PromptStatus.OK)
                    return;
                ent = (Entity)tr.GetObject(res.ObjectId, OpenMode.ForRead);
                if (ent == null)
                    return;
                Curve pline = (Curve)ent as Curve;
                if (pline == null) return;
                Point3dCollection pts = new Point3dCollection();
                line.IntersectWith(pline, Intersect.OnBothOperands, pts, 0, 0);//<-- A2010
                if (pts.Count == 0) return;
                List<Point3d> points = new List<Point3d>();

                foreach (Point3d p in pts)
                    points.Add(p);
                Point3d sp = line.StartPoint;
                points.Sort(delegate(Point3d p1, Point3d p2)
                {
                    return Convert.ToInt32(
                            Convert.ToDouble(sp.DistanceTo(p1).CompareTo(
               Convert.ToDouble(sp.DistanceTo(p2)))));
                }
);
                pts = new Point3dCollection(points.ToArray());
                DBObjectCollection objs = line.GetSplitCurves(pts);
                List<DBObject> lstobj = new List<DBObject>();
               
                foreach (DBObject dbo in objs)
                    lstobj.Add(dbo);
  

                BlockTableRecord btr = (BlockTableRecord)tr.GetObject(db.CurrentSpaceId, OpenMode.ForWrite);
                int i=1;
                foreach (DBObject dbo in objs)
                {
                    Line ln = dbo as Line;
                    if (!ln.IsWriteEnabled)
                        ln.UpgradeOpen();
                    ln.SetPropertiesFrom(line);
                    ln.ColorIndex=i;
                    btr.AppendEntity(ln);
                    tr.AddNewlyCreatedDBObject(ln, true);
                    if (i > 255)
                    {
                        i = 1;
                    }
                    else
                    {
                        i += 1;
                    }                  
                }


                if (!line.IsWriteEnabled)
                    line.UpgradeOpen();
                line.Erase();
                line.Dispose();

                ed.Regen();
                tr.Commit();
            }
        }
论坛插件加载方法
发帖求助前要善用【论坛搜索】功能,那里可能会有你要找的答案;
如果你在论坛求助问题,并且已经从坛友或者管理的回复中解决了问题,请把帖子标题加上【已解决】;
如何回报帮助你解决问题的坛友,一个好办法就是给对方加【D豆】,加分不会扣除自己的积分,做一个热心并受欢迎的人!
您需要登录后才可以回帖 登录 | 立即注册

本版积分规则

QQ|申请友链|Archiver|手机版|小黑屋|辽公网安备|晓东CAD家园 ( 辽ICP备15016793号 )

GMT+8, 2024-11-17 22:46 , Processed in 0.230699 second(s), 27 queries , Gzip On.

Powered by Discuz! X3.5

© 2001-2024 Discuz! Team.

快速回复 返回顶部 返回列表